#ifndef _fencer_hashmap_h
#define _fencer_hashmap_h

#include "stdint.h"
#include "list.h"

typedef uintptr_t (*HashFn)(void*);

typedef struct HashMap {
    HashFn hasher;
    List data;
    size_t key_size;
    size_t value_size;
} HashMap;

extern HashMap hash_map_from_sizes(size_t key_size, size_t value_size, HashFn hasher);
extern void hash_map_empty(HashMap* self);
extern void hash_map_insert(HashMap* self, void* key, void* value);
extern void hash_map_erase(HashMap* self, void* key);
extern void* hash_map_at(HashMap* self, void* key);

#define hash_map_at_as(__Type, __Map, __Key)\
    ((__Type*)hash_map_at(__Map, __Key))

#define hash_map_from_types(__KType, __VType, __Hasher)\
    (hash_map_from_sizes(sizeof(__KType), sizeof(_VType), __Hasher))

#endif // !_fencer_hashmap_h
